The 15th Zhejiang University Programming Contest 部分题解

比赛链接: here 题目对应到ZOJ3860~3868 A ZOJ3860 Find the Spy 水题,不能多说。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
/* ***************

Author :kuangbin

Created Time :2015/4/12 13:29:56

File Name :F:\2015ACM\比赛练习\A.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

int a[1100];

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

int n;

scanf("%d",&T);

while(T--){

scanf("%d",&n);

for(int i = 0;i < n;i++)

scanf("%d",&a[i]);

int id;

for(int i = 1;i < n;i++)

if(a[i] != a[i-1]){

id = i;

break;

}

for(int i = 0;i < n;i++)

if(i != id && a[i] == a[id]){

id--;

break;

}

printf("%d\n",a[id]);

}

return 0;

}

B ZOJ3861 Valid Pattern Lock 水题,暴力

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
/* ***************

Author :kuangbin

Created Time :2015/4/12 13:34:31

File Name :F:\2015ACM\比赛练习\B.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

int a[10];

bool vis[3][3];

int n;

bool check(){

memset(vis,false,sizeof(vis));

vis[(a[0]-1)/3][(a[0]-1)%3] = true;

for(int i = 1;i < n;i++){

int px = (a[i-1]-1)/3;

int py = (a[i-1]-1)%3;

int nx = (a[i]-1)/3;

int ny = (a[i]-1)%3;

if(vis[nx][ny])return false;

if(px == nx){

if(py+ny == 2 && !vis[px][1])return false;

}

if(py == ny){

if(px+nx == 2 && !vis[1][ny])return false;

}

if(!vis[1][1]){

if(px == 0 && py == 2 && nx == 2 && ny == 0)return false;

if(nx == 0 && ny == 2 && px == 2 && py == 0)return false;

if(px == 0 && py == 0 && nx == 2 && ny == 2)return false;

if(nx == 0 && ny == 0 && px == 2 && py == 2)return false;

}

vis[nx][ny] = true;

}

return true;

}

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

scanf("%d",&T);

while(T--){

scanf("%d",&n);

for(int i = 0;i < n;i++)

scanf("%d",&a[i]);

int ans = 0;

sort(a,a+n);

do{

if(check()){

ans++;

}

}

while(next_permutation(a,a+n));

printf("%d\n",ans);

sort(a,a+n);

do{

if(check()){

for(int i = 0;i < n;i++){

printf("%d",a[i]);

if(i < n-1)printf(" ");

else printf("\n");

}

}

}

while(next_permutation(a,a+n));

}

return 0;

}

C ZOJ3862 Intersection 简单题。 就是给了n对点,有n对边,要最多交换n+10次,让两两之间没有交点。 其实题目骗了你,最多交换n次就可以达到要求的。 首先你先构造出一种连边方案,使得两两间没有交点。 我的构造方法是把点按照x从小到大排序,再按照y从小到大排序。 最后两两相邻的连边就是没有交点的了。 最后其实就是要交换一下编号,使得和原来的一样。最多n次交换完成。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
/* ***************

Author :kuangbin

Created Time :2015/4/12 16:22:59

File Name :F:\2015ACM\比赛练习\C.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

struct Point{

int x,y;

int index;

bool operator <(const Point &b)const{

if(x != b.x)return x < b.x;

else return y < b.y;

}

void input(int ii){

scanf("%d%d",&x,&y);

index = ii;

}

}p[200010];

int a[200010],b[200010];

int id[200010];

int fid[200010];

pair<int,int>pp[200010];

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

int n;

scanf("%d",&T);

while(T--){

scanf("%d",&n);

for(int i = 1;i <= 2*n;i++){

p[i].input(i);

}

sort(p+1,p+2*n+1);

for(int i = 1;i <= 2*n;i += 2){

a[p[i].index] = p[i+1].index;

a[p[i+1].index] = p[i].index;

}

for(int i = 1;i <= 2*n;i++){

id[i] = i;

fid[i] = i;

}

int u,v;

for(int i = 1;i <= n;i++){

scanf("%d%d",&u,&v);

b[u] = v;

b[v] = u;

}

int cnt = 0;

for(int i = 1;i <= 2*n;i++)

if(id[a[i]] != b[id[i]]){

pp[cnt++] = make_pair(b[id[i]],id[a[i]]);

int tmp = b[id[i]];

id[fid[b[id[i]]]] = id[a[i]];

fid[id[a[i]]] = fid[b[id[i]]];

id[a[i]] = tmp;

fid[tmp] = a[i];

}

printf("%d\n",cnt);

for(int i = 0;i < cnt;i++)

printf("%d %d\n",pp[i].first,pp[i].second);

}

return 0;

}

D ZOJ3863 Paths on the Tree 留个坑!!!!待填。 E ZOJ3864 Quiz for EXO-L 要把图案识别出来。 进行八邻域的bfs。 搞出黑和白的连通块。 然后发现只有样例的两个连通块个数是一样的。 特判下就好。 可以采用大黑块和小黑块比例去区别。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

int g[1010][1010];

bool vis[1010][1010];

int Move[][2] = { {0,1},{0,-1},{1,0},{-1,0},{1,1},{1,-1},{-1,1},{-1,-1}};

int n;

int bfs(int x,int y){

queue<pair<int,int> >q;

q.push(make_pair(x,y));

vis[x][y] = true;

int cnt = 0;

while(!q.empty()){

pair<int,int>tmp = q.front();

cnt++;

q.pop();

int tx = tmp.first;

int ty = tmp.second;

for(int i = 0;i < 8;i++){

int nx = tx+Move[i][0];

int ny = ty+Move[i][1];

if(nx < 0 || nx >= n || ny < 0 || ny >= n)continue;

if(g[nx][ny] != g[x][y])continue;

if(vis[nx][ny])continue;

vis[nx][ny] = true;

q.push(make_pair(nx,ny));

}

}

return cnt;

}

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

scanf("%d",&T);

srand(time(NULL));

int m;

while(T--){

scanf("%d%d",&n,&m);

int x = 1, y = 1;

int t;

for(int i = 0;i < m;i++){

scanf("%d",&t);

while(t--){

g[x][y] = (i%2 == 0);

y++;

if(y == n+1){

x++;

y = 1;

}

}

}

n += 2;

for(int i = 0;i < n;i++){

g[i][0] = 1;

g[0][i] = 1;

g[n-1][i] = 1;

g[i][n-1] = 1;

}

int c1 = 0, c2 = 0;

memset(vis,false,sizeof(vis));

for(int i = 0;i < n;i++)

for(int j = 0;j < n;j++)

if(!vis[i][j]){

bfs(i,j);

if(g[i][j])c1++;

else c2++;

}

//printf("%d %d\n",c1,c2);

if(c1== 2 && c2 == 9)printf("Baekhyun\n");

else if(c1 == 1 && c2 == 5)printf("Chanyeol\n");

else if(c1 == 3 && c2 == 1)printf("Chen\n");

else if(c1 == 2 && c2 == 1)printf("D.O\n");

else if(c1 >= 10)printf("Kai\n");

else if(c1 == 1 && c2 == 3 )printf("Kris\n");

else if(c1 == 2 && c2 == 6)printf("Lay\n");

else if(c1 == 8 && c2 == 5)printf("Luhan\n");

//else if(c1 == 2 && c2 == 5)printf("Sehun\n");

else if(c1 == 8 && c2 == 2)printf("Suho\n");

else if(c1 == 4 && c2 == 2)printf("Tao\n");

else if(c1 == 2 && c2 == 5){

memset(vis,false,sizeof(vis));

int a[10];

int cc = 0;

for(int i = 0;i < n;i++)

for(int j = 0;j < n;j++)

if(!vis[i][j] && g[i][j] == 0){

a[cc++] = bfs(i,j);

}

sort(a,a+cc);

if(1.0*a[cc-1]/a[0] < 20)printf("Xiumin\n");

else printf("Sehun\n");

}

else while(1);

}

return 0;

}

F ZOJ3865 Superbot 简单搜索。 状态就是当前位置,已经光标的位置。 水题。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
/* ***************

Author :kuangbin

Created Time :2015/4/12 14:27:47

File Name :F:\2015ACM\比赛练习\F.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

int Move[][2] = { {0,-1},{0,1},{-1,0},{1,0}};

int dp[20][20][4];

char g[20][20];

int ex,ey;

int n,m,P;

bool can(int x,int y){

if(x < 0 || x >= n)return false;

if(y < 0 || y >= m)return false;

if(g[x][y] == '*')return false;

return true;

}

struct Node{

int x,y;

int dir;

Node(int _x = 0,int _y = 0,int _dir = 0){

x = _x;

y = _y;

dir = _dir;

}

};

int bfs(int sx,int sy){

memset(dp,-1,sizeof(dp));

queue<Node>q;

q.push(Node(sx,sy,0));

dp[sx][sy][0] = 0;

while(!q.empty()){

Node tmp = q.front();

q.pop();

int x = tmp.x;

int y = tmp.y;

int dir = tmp.dir;

//printf("%d %d %d %d\n",x,y,dir,dp[x][y][dir]);

if(x == ex && y == ey)return dp[x][y][dir];


int nx,ny,nd;
nx = x; ny = y; nd = dir;
if(dp\[x\]\[y\]\[dir\] >= 0 && dp\[x\]\[y\]\[dir\]%P == P-1){
nd = (nd+3)%4;
}
if(dp\[nx\]\[ny\]\[nd\] == -1){
dp\[nx\]\[ny\]\[nd\] = dp\[x\]\[y\]\[dir\]+1;
q.push(Node(nx,ny,nd));
}

nx = x+Move\[dir\]\[0\];
ny = y+Move\[dir\]\[1\];
nd = dir;
if(can(nx,ny)){
if(dp\[x\]\[y\]\[dir\] >= 0 && dp\[x\]\[y\]\[dir\]%P == P-1)
nd = (nd+3)%4;
if(dp\[nx\]\[ny\]\[nd\] == -1){
dp\[nx\]\[ny\]\[nd\] = dp\[x\]\[y\]\[dir\]+1;
q.push(Node(nx,ny,nd));
}
}

nx = x;
ny = y;
nd = (dir+3)%4;
if(dp\[x\]\[y\]\[dir\] >= 0 && dp\[x\]\[y\]\[dir\]%P == P-1){
nd = (nd+3)%4;
}
if(dp\[nx\]\[ny\]\[nd\] == -1){
dp\[nx\]\[ny\]\[nd\] = dp\[x\]\[y\]\[dir\]+1;
q.push(Node(nx,ny,nd));
}

nx = x;
ny = y;
nd = (dir+1)%4;
if(dp\[x\]\[y\]\[dir\] >= 0 && dp\[x\]\[y\]\[dir\]%P == P-1){
nd = (nd+3)%4;
}
if(dp\[nx\]\[ny\]\[nd\] == -1){
dp\[nx\]\[ny\]\[nd\] = dp\[x\]\[y\]\[dir\]+1;
q.push(Node(nx,ny,nd));
}
}
return -1;
}

int main()
{
//freopen("in.txt","r",stdin);
//freopen("out.txt","w",stdout);
int T;
scanf("%d",&T);
while(T--){
scanf("%d%d%d",&n,&m,&P);
for(int i = 0;i < n;i++)
scanf("%s",g\[i\]);
int sx,sy;
for(int i = 0;i < n;i++){
for(int j = 0;j < m;j++){
if(g\[i\]\[j\] == '@'){
sx = i;
sy = j;
}
if(g\[i\]\[j\] == '$'){
ex = i;
ey = j;
}
}
}
int ans = bfs(sx,sy);
if(ans == -1)printf("YouBadbad\\n");
else printf("%d\\n",ans);
}
return 0;
}

G ZOJ3866 Cylinder Candy 数学题,推公式。 积分算表面积和体积。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
/* ***************

Author :kuangbin

Created Time :2015/4/12 16:12:16

File Name :F:\2015ACM\比赛练习\G.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

const double PI = acos(-1.0);

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

double r,h,d;

scanf("%d",&T);

while(T--){

scanf("%lf%lf%lf",&r,&h,&d);

double s = 2*d*r*PI*PI + 2*(r*r+r*h+d*h+2*d*d)*PI;

double v = ((6*d*(d*d+r*r)-2*d*d*d)*PI+3*r*d*d*PI*PI)/3 + (r+d)*(r+d)*h*PI;

printf("%.10lf %.10lf\n",v,s);

}
return 0;

}

H ZOJ3867 Earthstone: Easy Version 水题,不能多说。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
/* ***************

Author :kuangbin

Created Time :2015/4/12 13:58:09

File Name :F:\2015ACM\比赛练习\H.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int a,b,c,d;

int T;

scanf("%d",&T);

while(T--){

scanf("%d%d%d%d",&a,&b,&c,&d);

if(a == 0){

printf("Invalid\n");

continue;

}

b -= c;

d -= a;

if(b > 0)printf("%d %d ",a,b);

else printf("Discard ");

if(d > 0)printf("%d %d\n",c,d);

else printf("Discard\n");

}

return 0;

}

I ZOJ3868 GCD Expectation 一眼题。 暴力统计。 比如用dp[i] 表示gcd为i的子集个数。 那么如果i的倍数有x个, 那么gcd为 i的倍数的子集个数就是 2^x - 1。 要算gcd恰好为i的,那么就减掉就好。 dp[i] = 2^x - 1; for(int j = i+i;j <= Max;j += i) dp[i] -= dp[j]; 倒过来求dp[i]就好。 复杂度就是调和级数的复杂度nln n. 简单题啊。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
/* ***************

Author :kuangbin

Created Time :2015/4/12 14:12:03

File Name :F:\2015ACM\比赛练习\I.cpp

************************************************ */

#include <stdio.h>

#include <string.h>

#include <iostream>

#include <algorithm>

#include <vector>

#include <queue>

#include <set>

#include <map>

#include <string>

#include <math.h>

#include <stdlib.h>

#include <time.h>

using namespace std;

const int MOD = 998244353;

const int MAXN = 1000010;

int a[MAXN];

int b[MAXN];

long long pow_m(long long a,long long n){

long long ret = 1;

long long tmp = a;

while(n){

if(n&1)ret = ret*tmp%MOD;

tmp = tmp*tmp%MOD;

n >>= 1;

}

return ret;

}

long long dp[MAXN];

int main()

{

//freopen("in.txt","r",stdin);

//freopen("out.txt","w",stdout);

int T;

memset(b,0,sizeof(b));

scanf("%d",&T);

int k;

int n;

while(T--){

scanf("%d%d",&n,&k);

int Max = 0;

for(int i = 0;i < n;i++){

scanf("%d",&a[i]);

b[a[i]]++;

Max = max(a[i],Max);

}

long long ans = 0;

for(int i = Max;i >= 1;i--){

dp[i] = 0;

int cc = 0;

for(int j = i;j <= Max;j+= i){

cc += b[j];

if(j > i)dp[i] = (dp[i]-dp[j]+MOD)%MOD;

}

dp[i] = (dp[i] + pow_m(2,cc) - 1 + MOD)%MOD;

ans += dp[i]*pow_m(i,k)%MOD;

ans %= MOD;

}

for(int i = 0;i < n;i++)

b[a[i]]--;

printf("%d\n",(int)ans);

}

return 0;

}
------ 本文结束------
  • 本文作者: kuangbin
  • 本文链接: 583.html
  • 版权声明: 本博客所有文章除特别声明外,均采用 CC BY-NC-SA 4.0 许可协议。转载请注明出处!
0%